/*
 * Copyright (c) 2023, Cloudera, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

DROP TABLE IF EXISTS HDFS_LOCATION_TEMP;

CREATE TABLE IF NOT EXISTS HDFS_LOCATION_TEMP
(
    PATH                 VARCHAR2(MAX) primary key,
    REPLICATION          BIGINT not null,
    MODIFICATION_TIME    TIMESTAMP,
    ACCESS_TIME          TIMESTAMP,
    PREFERRED_BLOCK_SIZE BIGINT not null,
    BLOCKS_COUNT         BIGINT not null,
    FILE_SIZE            BIGINT not null,
    NSQUOTA              BIGINT not null,
    DSQUOTA              BIGINT not null,
    PERMISSION           CHARACTER VARYING(255),
    USER_NAME            CHARACTER VARYING(255),
    GROUP_NAME           CHARACTER VARYING(255)
)
AS
SELECT PATH, REPLICATION, MODIFICATIONTIME, ACCESSTIME, PREFERREDBLOCKSIZE, BLOCKSCOUNT, FILESIZE, NSQUOTA, DSQUOTA, PERMISSION, USERNAME, GROUPNAME
FROM CSVREAD('${path_to_csv_file}');


MERGE INTO HDFS_LOCATION AS T USING HDFS_LOCATION_TEMP AS S
ON T.PATH = S.PATH
WHEN NOT MATCHED THEN
    INSERT (PATH, REPLICATION, MODIFICATION_TIME, ACCESS_TIME, PREFERRED_BLOCK_SIZE, BLOCKS_COUNT, FILE_SIZE, NSQUOTA, DSQUOTA, PERMISSION, USER_NAME, GROUP_NAME, SOURCE_SERVER_ID, CLUSTER_ID)
    VALUES (S.PATH, S.REPLICATION, S.MODIFICATION_TIME, S.ACCESS_TIME, S.PREFERRED_BLOCK_SIZE, S.BLOCKS_COUNT, S.FILE_SIZE, S.NSQUOTA, S.DSQUOTA, S.PERMISSION, S.USER_NAME, S.GROUP_NAME, ${sourceServerId}, '${clusterName}');

