/*
 * Copyright (c) 2023, Cloudera, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

DROP TABLE IF EXISTS HIVE_TABLE_TEMP;

CREATE TABLE IF NOT EXISTS HIVE_TABLE_TEMP
(
    NAME              CHARACTER VARYING(255) not null,
    TBL_NAME          CHARACTER VARYING(255) not null,
    IS_PARTITIONED    BOOLEAN not null,
    PKEY_NAME         CHARACTER VARYING(255),
    PARTITION_COUNT   BIGINT not null,
    TBL_TYPE          CHARACTER VARYING(255),
    DB_LOCATION_URI   VARCHAR2(MAX),
    LOCATION          VARCHAR2(MAX),
    primary key (NAME, TBL_NAME)
)
AS
SELECT NAME,TBL_NAME,IS_PARTITIONED,PKEY_NAME,PARTITION_COUNT,TBL_TYPE,DB_LOCATION_URI,LOCATION
FROM CSVREAD('${path_to_csv_file}');


MERGE INTO HIVE_TABLE AS T USING HIVE_TABLE_TEMP AS S
ON T.NAME = S.NAME AND T.TBL_NAME = S.TBL_NAME
WHEN NOT MATCHED THEN
    INSERT (NAME, TBL_NAME, IS_PARTITIONED, PKEY_NAME, PARTITION_COUNT, TBL_TYPE, DB_LOCATION_URI, LOCATION, SOURCE_SERVER_ID, CLUSTER_ID)
    VALUES (S.NAME, S.TBL_NAME, S.IS_PARTITIONED, S.PKEY_NAME, S.PARTITION_COUNT, S.TBL_TYPE, S.DB_LOCATION_URI, S.LOCATION, ${sourceServerId}, '${clusterName}');

